package huffman;

public class Utilities {
	
	static void frequencyCount( char[] in, int[] frequency ) {
		Assert.check( in != null ) ;
		Assert.check( frequency != null ) ;
		int numberOfSymbols = frequency.length ;
		for( int c = 0 ; c < numberOfSymbols ; ++c ) {
			frequency[c] = 0 ; }
		for( int i = 0 ; i < in.length ; ++i ) {
			Assert.check( 0 <= in[i] && in[i] < numberOfSymbols ) ;
			frequency[ (int)in[i] ] += 1 ;
		}
	}
	
	static void sort( int[] frequency, char[] symbol ) {
		Assert.check( frequency != null ) ;
		Assert.check( symbol != null ) ;
		Assert.check( symbol.length == frequency.length ) ;
		int numberOfSymbols = frequency.length ;
		
		for( int i=0 ; i<numberOfSymbols-1 ; ++i ) {
			// find the position p of the largest
			// of the item in range {i,..NUMBER_OF_SYMBOLS}
			int p = i ;
			for( int q=i+1 ; q<numberOfSymbols ; ++q) {
				if( frequency[q] > frequency[p] ) p = q ; }
			// Swap frequencies
			int temp = frequency[i] ;
			frequency[i] = frequency[p] ;
			frequency[p] = temp ;
			// Swap symbols
			char tempChar = symbol[i] ;
			symbol[i] = symbol[p] ;
			symbol[p] = tempChar ;
		}
	}
}
