package huffman;

import java.util.Scanner;

public class Main {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		Scanner scanner = new Scanner(System.in) ;
		while(true) {
			System.out.println("Enter a line of text (quit) to end") ;
			
			// Get alin of text and put it in array "chars"
			String line = scanner.nextLine() ;
			if( line.toLowerCase().equals("quit") ) break ;
			char [] chars = line.toCharArray() ;
			
			// Find how many symbols we need.
			char max = (char)0;
			for( int i = 0 ; i < chars.length ; ++i )
				if( chars[i] > max ) max = chars[i] ;
			
			// Compute the frequency of all symbols used.
			int[] frequencies = new int[max+1] ;
			Utilities.frequencyCount(chars, frequencies);
			
			// Sort the frequencies and compute the symbols array
			char[] symbols = new char[max+1] ;
			for( char i = 0 ; i < max+1 ; ++i ) symbols[i] = i ;
			Utilities.sort( frequencies, symbols) ;
			
			// Make a Huffman tree
			Tree tree = new Tree(frequencies, symbols) ;
			
			// Encode the "chars" array.
			MockBooleanSequence seq = new MockBooleanSequence() ;
			for( int i = 0 ; i < chars.length ; ++i) {
				int start = seq.size() ;
				tree.encode(chars[i], seq) ;
				System.out.print("'" +chars[i]+ "'") ;
				for( int j = start ; j < seq.size() ; ++j) 
					if(seq.get(j)) System.out.print("1") ; else System.out.print("0") ;
				System.out.print(" ") ;
			}
			System.out.println();
			System.out.println( seq.size()+ " bits " );
			for( boolean p : seq ) {
				if(p) System.out.print("1") ; else System.out.print("0") ;
			}
			System.out.println() ;
			
			// Decode and output.
			StringBuffer buf = new StringBuffer() ;
			while( !seq.isEmpty() ) {
				char ch = tree.decode(seq) ;
				buf.append(ch) ; }
			System.out.println(buf.toString()) ;
		}
	}

}
