package huffman;

import org.junit.Assert;
import org.junit.Test;

public class TestDecode {
	@Test public void testDecode() {
		LeafNode leaf0 = new LeafNode('a', 15) ;
		LeafNode leaf1 = new LeafNode('e', 16) ;
		LeafNode leaf2 = new LeafNode('k', 17) ;
		LeafNode leaf3 = new LeafNode('g', 7) ;
		LeafNode leaf4 = new LeafNode('h', 10) ;

		BranchNode branch5 = new BranchNode(leaf0, leaf1) ;
		BranchNode branch6 = new BranchNode(leaf3, leaf4) ;
		BranchNode branch7 = new BranchNode(leaf2, branch6 ) ;
		BranchNode root = new BranchNode(branch5, branch7 ) ;
		
		MockBooleanSequence seq = new MockBooleanSequence() ;
		seq.put( true ) ;
		seq.put( true ) ;

		seq.put( true ) ;
		seq.put( false ) ;

		seq.put( false ) ;
		seq.put( true ) ;

		seq.put( false ) ;
		seq.put( false ) ;
		seq.put( true ) ;

		seq.put( false ) ;
		seq.put( false ) ;
		seq.put( false ) ;
		
		char codePoint = root.decode( seq ) ;
		Assert.assertEquals('a', codePoint) ;
		
		codePoint = root.decode( seq ) ;
		Assert.assertEquals('e', codePoint) ;
		
		codePoint = root.decode( seq ) ;
		Assert.assertEquals('k', codePoint) ;
		
		codePoint = root.decode( seq ) ;
		Assert.assertEquals('g', codePoint) ;
		
		codePoint = root.decode( seq ) ;
		Assert.assertEquals('h', codePoint) ;
		
		Assert.assertEquals(0, seq.size() ) ;
	}

}
