package huffman;

import org.junit.Assert;

public class TestUtilities {


	static void compareSeq(MockBooleanSequence seq, boolean[] bools) {
		Assert.assertEquals(bools.length, seq.size() ) ;
		
		for( int i = 0 ; i < bools.length ; ++i ) {
			Assert.assertEquals("at location "+i, bools[i], seq.get(i)) ;
		}
	}

	static void encodeMessage(Tree tree, char[] message, BooleanSink sink) {
		for( char i : message ) {
			tree.encode(i, sink) ;
		}
	}

	static char[] decodeMessage(Tree tree, BooleanSource seq, int len) {
		char[] result = new char[len] ;
		for( int i=0 ; i<len ; ++i) {
			result[i] = tree.decode( seq ) ; }
		return result ;
	}

	public static void compareArrays(char[] expected, char [] actual) {
		Assert.assertEquals(expected.length, actual.length) ;
		for( int i=0 ; i<expected.length ; ++i )
			Assert.assertEquals(expected[i], actual[i]) ;
	}
}
